function onMainLoad() {
  window.client = new MSNObject();
  window.client.loadPrefs();
}

function onMainUnload() {
  for (var sessionID in window.client.sessions) {
    var session = window.client.sessions[sessionID];
    session.exit();
    if (typeof(session._WINDOW) == "object")
      session._WINDOW.close();
  }
  if (window.client.isConnected == true) {
    window.client.logout();
  }
  delete window.client;
}

function signIn() {
  var email = document.getElementById("email");
  var status = document.getElementById("initial-status").value;
  var re = /^.*\@.*\..*$/i; // valid e-mail in RegExp format
  var valid = re.exec(email.value); // check if the e-mail address is valid
  if (!valid) {
    alert(window.client.bundle.GetStringFromName("invalidEMail"));
    return;
  }
  document.getElementById("signin-button").disabled = true;
  window.client.logon(email.value,
    document.getElementById("password").value, status);
  document.getElementById(status + "_menuitem").checked = true;
  document.getElementById("main-pages").selectedIndex = 1;
}

function signOut(timedout) {
  document.getElementById("signin-button").disabled = false;
  var pb = document.getElementById("SignInProgress")
  pb.mode = "undetermined";
  pb.value = 0;
  document.getElementById("main-pages").selectedIndex = 0;
  window.client.logout();
    
  //if (timedout)
  //    setTimeout("signIn()", 0);
}

function setupContactlist() {
  document.getElementById("nickname").value = window.client.nickname;
  var list = document.getElementById("offline-contacts-list");
  for (var email in window.client.contactlist["FL"]) {
    contact = window.client.contactlist["FL"][email];
    addContact(contact.email, contact.nickname, contact.status);
  }
}

function loginSuccessful() {
  document.getElementById("main-pages").selectedIndex = 2;
}

function addOnlineContact(email, nick, status) {
  var list = document.getElementById("offline-contacts-list");
  var contactNode = document.getElementById(email);
  contactNode.setAttribute("nickname", nick);
  if (status == "NLN") {
    contactNode.setAttribute("label", " " + nick);
  }
  else {
    contactNode.setAttribute("label", " " + nick + " (" + window.client.bundle.GetStringFromName("StatusMsg" + status) + ")");
  }
  contactNode.setAttribute("src", StatusImages[status]);
  var movingContactNode = list.removeChild(contactNode.parentNode.parentNode);
  document.getElementById("online-contacts-list").appendChild(movingContactNode);
}

function addOfflineContact(email, nick, status) {
  var list = document.getElementById("online-contacts-list");
  var contactNode = document.getElementById(email);
  contactNode.setAttribute("label", " " + nick);
  contactNode.setAttribute("src", StatusImages[status]);
  var movingContactNode = list.removeChild(contactNode.parentNode.parentNode);
  document.getElementById("offline-contacts-list").appendChild(movingContactNode);
}

function confirmContactAdd() {
  openWindowOnce("chrome://msnmsgr/contact/addcontact.xul", "msnsmgr:add-contact", "chrome");
}

function confirmContactDelete() {
  var tree = document.getElementById("contact-list-tree");
  var contactNode = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  if (confirm(window.client.bundle.GetStringFromName("contactDelete") + " " + contactNode.getAttribute("label") + " (" + contactNode.id + ")" + " ?")) {
    window.client.removeContact("FL", contactNode.id);
  }
}

function addContact(email, nickname, status) {
  var list = document.getElementById("offline-contacts-list");
  ti = createContactNode(email, nickname, status, StatusImages[status]);
  if (window.client.isContactInList(email, "BL")) {
    ti.firstChild.firstChild.setAttribute("label", " " + nickname + " (" + window.client.bundle.GetStringFromName("StatusMsgBLK") + ")");
    ti.firstChild.firstChild.setAttribute("src", StatusImages["BLK"]);
  }
  list.appendChild(ti);
}

function removeContact(email) {
  var contactNode = document.getElementById(email);
  var list = contactNode.parentNode.parentNode.parentNode;
  list.removeChild(contactNode.parentNode.parentNode);
}

function changeStatus(status) {
  window.client.changeStatus(status);
}

function changeNickname(nickname) {
  var currentNickname = document.getElementById("nickname").value;
  if (nickname.replace(/^\s+|\s+$/, "") != "" && nickname != currentNickname) {
    window.client.changeNickname(nickname);
    document.getElementById("nickname-deck").selectedIndex = "0";
  }
}

function statusChanged(status) {
  var statusdesc = document.getElementById("status-description");
  statusdesc.value = window.client.bundle.GetStringFromName("YourStatusMsg" + status);
}

function nicknameChanged(nickname) {
  document.getElementById("nickname").value = nickname;
}

function contactStatusChanged(email, status) {
  var contactNode = document.getElementById(email);
  if (status != "NLN") {
    contactNode.setAttribute("label", " " + contactNode.getAttribute("nickname") + " (" + window.client.bundle.GetStringFromName("StatusMsg" + status) + ")");
  }
  else {
    contactNode.setAttribute("label", " " + contactNode.getAttribute("nickname"));
  }
  contactNode.setAttribute("src", StatusImages[status]);
}

function contactNicknameChanged(email, nick) {
  var contactNode = document.getElementById(email);
  if (!(window.client.isContactInList(email, "BL"))) {
    var status = window.client.getContactStatus(email);
    if (status == "NLN") {
      contactNode.setAttribute("label", " " + nick);
    }
    else {
      contactNode.setAttribute("label", " " + nick + " (" + window.client.bundle.GetStringFromName("StatusMsg" + status) + ")");
    }
  }
  else {
    contactNode.setAttribute("label", " " + nick + " (" + window.client.bundle.GetStringFromName("StatusMsgBLK") + ")");
  }
  contactNode.setAttribute("nickname", nick);
}

function toggleBlock() {
  var tree = document.getElementById("contact-list-tree");
  var contactNode = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  var email = contactNode.id;
  var nick = contactNode.getAttribute("nickname");
  if (window.client.isContactInList(email, "BL")) {
    var status = window.client.getContactStatus(email);
    window.client.moveContactBetweenLists("BL", "AL", email, escape(nick));
    if (status == "NLN" || status == "FLN") {
      contactNode.setAttribute("label", " " + nick);
    }
    else {
      contactNode.setAttribute("label", " " + nick + " (" + window.client.bundle.GetStringFromName("StatusMsg" + status) + ")");
    }
    contactNode.setAttribute("src", StatusImages[status]);
  }
  else {
    window.client.moveContactBetweenLists("AL", "BL", contactNode.id, escape(nick));
    contactNode.setAttribute("label", " " + nick + " (" + window.client.bundle.GetStringFromName("StatusMsgBLK") + ")");
    contactNode.setAttribute("src", StatusImages["BLK"]);
  }
}

function setupSession() {
  var tree = document.getElementById("contact-list-tree");
  var item = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  var win = window.client.getSessionWindow(item.id);
  if (win == null) {
    win = window.open("chrome://msnmsgr/content/session.xul", "_blank", "chrome,resizable");
    win._CONTACT = item.id;
    win._SESSION = new MSNSession(window.client, win);
    window.client.grabSession(win._SESSION);
  }
  else {
    win.focus();
  }
}

function menuSendIM() {
  var item = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  if (item.id != "emailItem" && item.id != "online" && item.id != "offline") {
    setupSession();
  }
}

function sendEmail(contact) {
  alert("Not implemented yet.");
}

function viewProfile() {
  var tree = document.getElementById("contact-list-tree");
  var item = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  window.open("http://members.msn.com/default.msnw?mem=" + item.id, "_BLANK");
}

function onContextMenu(tree, event) {
    var item = tree.view.getItemAtIndex(tree.currentIndex);
    var section = item.parentNode;
    var cell = item.firstChild.firstChild;
    if (cell.id == "online" || cell.id == "offline" || cell.id == "emailItem") {
        return false;
    }
}

function editNickname() {
  document.getElementById("nickname-deck").selectedIndex="1";
  document.getElementById("nickname-textbox").focus();
}

function updateEmailItem(emails) {
  switch (emails) {
    case 0:
      emails = window.client.bundle.GetStringFromName("noNewEmail");
      break;
    case 1:
      emails = window.client.bundle.GetStringFromName("oneNewEmail");
      break;
    default:
      emails = emails + " " +window.client.bundle.GetStringFromName("newEmail");
      break;
  }
  window.document.getElementById("emailItem").setAttribute("label", emails);
}

function contactDblClick(tree, event) {
  if (event.button == 0) {
    var item = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
    if (item.id == "emailItem") {
      alert("Not implemented yet.");
    }
    else if (item.id != "online" && item.id != "offline") {
      setupSession();
    }
  }
}

function createContactNode(email, nickname, status, statimg) {
    var ti = document.createElement("treeitem");
    var tr = document.createElement("treerow");
    var tc = document.createElement("treecell");
    var str = " " + nickname;
    if ((status != "NLN") && (status != "FLN")) {
        str += " (" + client.bundle.GetStringFromName("StatusMsg" + status) + ")";
    }
    tc.setAttribute("label", " " + str);
    tc.setAttribute("nickname", nickname);
    tc.setAttribute("id", email);
    tc.setAttribute("src", statimg);
    tr.appendChild(tc);
    ti.appendChild(tr);
    return ti;
}