function onSessionLoad() {
  this.dontSend = false;
  this.onUsersChanged();
  if (typeof(window._MSG) != "undefined") { // From first incoming message
    var m = window._MSG;
    this.onMessageReceived(m[0], m[1], m[2], m[3]);
    delete window._MSG;
  }
  FontChanged();
  doTextSizeChange('small');
  document.getElementById('message').focus();
}

function onSessionUnload() {
  window._SESSION.exit();
}

window.onUsersChanged = function onUsersChanged() {
    var value = '';
    for (var i in window._SESSION.Contacts) {
        var c = window._SESSION.Contacts[i];
        value += c.nickname + ' <' + c.email + '>, ';
    }
    if (value == '') { value = window._SESSION.bundle.GetStringFromName('toNoOne') + '  ' };
    value = window._SESSION.bundle.GetStringFromName('sendMessageToLabel') + '  ' + value.substr(0, value.length - 2);
    var cp = window.document.getElementById('chat-participants')
    cp.firstChild.nodeValue = value;
}

window.FontChanged = function FontChanged() {
  document.getElementById('message').setAttribute('style', window._SESSION._CLIENT.CSS);
}

function doTextSizeChange(cls) {
  document.getElementById('chat-panel').contentDocument.body.setAttribute('class', cls);
  document.getElementById('message').setAttribute('class', cls);
}

window.appendAndScroll = function appendAndScroll(node) {
  var panel = document.getElementById('chat-panel').contentDocument;
  panel.body.appendChild(node);
  try {
    panel.defaultView.scrollTo(0, panel.body.offsetHeight);
  } catch (ex) {
    alert(ex);
  }
}

function sendIM(e) {
  if ((e.type == 'command') || (e.type == 'keypress' && e.keyCode == 13 && e.shiftKey == false)) {
    var msgText = window.document.getElementById('message').value;
    if (msgText != '') {
      window.document.getElementById('message').value = '';
      var msgNode = createMessageContentNode(window.document, msgText, window._SESSION._CLIENT.MMS);
      msgNode = createMessageNode(window.document, window._SESSION._CLIENT.nickname, msgNode, true);
      appendAndScroll(msgNode);
      e.preventDefault();
      e.stopPropagation();
      if (window._SESSION.isCallingContact() == false) {
        window._SESSION.send(msgText);
      }
      else {
        this._SESSION.bufferMsg(msgText);
      }
    }
  }
  else if (window.dontSend == false) {
    window.dontSend = true;
    if (window._SESSION.getContactCount() == 1) {
      if (window._SESSION.isConnected == true) {
        window._SESSION.recallContactIfGone(window._SESSION.getFirstContactID());
        window._SESSION.sendTyping();
        setTimeout('window.dontSend = false', 5000);
      }
      else {
        var newSession = new MSNSession(window._SESSION._CLIENT, window);
        window._CONTACT = window._SESSION.getFirstContactID();
        window._SESSION._CLIENT.grabSession(newSession);
        window._SESSION.exit();
        window._SESSION = newSession;
      }
    }
    else {
      window._SESSION.sendTyping();
      setTimeout('window.dontSend = false', 5000);
    }
  }
}

window.onMessageReceived = function onMessageReceived(from, fromEmail, headers, text) {
  switch (headers["content-type"]) {
    case "text/plain; charset=UTF-8":
      var textcontent = createMessageContentNode(window.document, text, headers['x-mms-im-format']);
      var msg = createMessageNode(window.document, from, textcontent);
      appendAndScroll(msg);
      var contact = null;
      contact = window._SESSION.getContact(fromEmail);
      contact.timeout = 0;
      _updateSB();
      window.getAttention();
      break;
    case "text/x-msmsgscontrol":
      var typinguser = headers["typinguser"];
      var contact = null;
      contact = window._SESSION.getContact(typinguser);
      contact.timeout = new Date().getTime();
      setTimeout('_updateSB()', 6000);
      _updateSB();
      break;
    case "text/x-msmsgsinvite":
      var h = new Array();
      var parts = text.split('\r\n');
      for (var i in parts) {
        var header = parts[i].split(": ");
        h[header[0]] = header[1];
      }
      if (h['Invitation-Command'] == 'INVITE')
        window._SESSION.cancelInvite(h['Invitation-Cookie'], "REJECT_NOT_INSTALLED");
      var msg = createNotifyNode(window.document, window._SESSION.bundle.GetStringFromName('InviteUnsupported'));
      appendAndScroll(msg);
      break;
  }
}

function _updateSB() {
  var statusMsg = '';
  var count = 0;
  var t = new Date().getTime();
  for (var i in window._SESSION.Contacts) {
    var contact = window._SESSION.Contacts[i];
    if (t <= contact.timeout + 5000) {
      count++;
      statusMsg += contact.nickname + ', ';
    }
  }
  switch (count) {
    case 0:
      statusMsg = '';
      break;
    case 1:
      var typingMsg = window._SESSION.bundle.GetStringFromName('isTyping');
      statusMsg = typingMsg.replace("%U", statusMsg.substr(0, statusMsg.length - 2));
      break;
    default:
      var typingMsg = window._SESSION.bundle.GetStringFromName('areTyping');
      statusMsg = typingMsg.replace("%U", statusMsg.substr(0, statusMsg.length - 2));
      break;
  }
  document.getElementById('status-bar-main').firstChild.setAttribute('label', statusMsg);
}